
/*
   This file is part of AirFart.

   AirFart is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   AirFart is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with AirFart; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef STATS_H
#define STATS_H

#include <stdio.h>
#include <vector>

#include "address.h"
#include "vendor.h"
#include "gui.h"

#define NOT_FOUND -1
//#define DDEBUG_STATS 1
//#define PRINT_AVERAGES 1

using std::vector;

class Stats {
	private:
		vector<Address*> address_vector;
		Vendor* vendor;
		bool use_gui;
	public:
		Stats(); 
		~Stats();

		void add_packet(unsigned char* ethaddr, char* ssid, int strength);
		void print_addresses();
		int find_address(unsigned char* new_addr);
		void update_gui(unsigned char* ethaddr, char* ssid, char* vendor_id, int packet_count);
		void unset_use_gui(); // This is used with the --nogui commandline option
};

#endif

