
/*
   This file is part of AirFart.

   AirFart is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   AirFart is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with AirFart; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef VENDOR_H
#define VENDOR_H

//#define DEBUG_VENDOR 1

#include <stdio.h>
#include <fstream>
#include <vector>

using std::ifstream;
using std::ios;
using std::vector;

struct Vendor_Struct {
	char* macaddr[8];  // This is of size 8 because there are 2 :'s in the file version of the macaddr
	char* vendor_name;
};

class Vendor
{
	private:
		vector<Vendor_Struct*> vendor_vector;

		int read_file(char* filename);
		void print_vendor_vector();		
	public:
		Vendor(); 
		~Vendor(); 
		char* get_vendor_info(unsigned char* ethaddr);
};

#endif

